// ScrollPopupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WinTest.h"
#include "ScrollPopupDlg.h"
#include "serial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScrollPopupDlg dialog


CScrollPopupDlg::CScrollPopupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScrollPopupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScrollPopupDlg)
	//}}AFX_DATA_INIT
}


void CScrollPopupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScrollPopupDlg)
	DDX_Control(pDX, IDC_SCROLL_RATE_PROMPT, m_Scroll_Rate_Prompt);
	DDX_Control(pDX, IDC_SCROLL_MESSAGE_TEXT, m_Scroll_Message_Text);
	DDX_Control(pDX, IDC_SCROLL_MESSAGE_PROMPT, m_Scroll_Message_Prompt);
	DDX_Control(pDX, IDC_SCROLL_STEP_SIZE, m_Scroll_Step_Size);
	DDX_Control(pDX, IDC_SCROLL_ROW, m_Scroll_Row);
	DDX_Control(pDX, IDC_SCROLL_RATE_SLIDER, m_Scroll_Rate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScrollPopupDlg, CDialog)
	//{{AFX_MSG_MAP(CScrollPopupDlg)
	ON_EN_CHANGE(IDC_SCROLL_MESSAGE_TEXT, OnChangeScrollMessageText)
	ON_WM_HSCROLL()
	ON_CBN_CLOSEUP(IDC_SCROLL_ROW, OnCloseupScrollRow)
	ON_CBN_CLOSEUP(IDC_SCROLL_STEP_SIZE, OnCloseupScrollStepSize)
	ON_BN_CLICKED(ID_SCROLL_GO, OnScrollGo)
	ON_BN_CLICKED(ID_SCROLL_STOP, OnScrollStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//------------------------------------------------------------------------------
BOOL CScrollPopupDlg::OnInitDialog() 
  {
	CDialog::OnInitDialog();

  m_Scroll_Message_Text.SetWindowText(scroll_message);
  Update_Message_Prompt();

	m_Scroll_Step_Size.SetCurSel(scroll_step_size);

  //Limit the row for 16x2 displays to 0-1 and 0-3 for 20x4.
  if((display_size?3:1)<scroll_row)
    scroll_row=1;
  m_Scroll_Row.SetCurSel(scroll_row);

	m_Scroll_Rate.SetRange(5,100);
	m_Scroll_Rate.SetPos(105-scroll_delay);
	Update_Scroll_Prompt();
	
	return TRUE;
  }
//------------------------------------------------------------------------------
void CScrollPopupDlg::Update_Scroll_Prompt(void)
  {
  int
    new_rate;
  char
    string[200];
  int
    step_size;
  step_size=m_Scroll_Step_Size.GetCurSel()+1;
  new_rate=105-m_Scroll_Rate.GetPos();
  sprintf(string,"Value=%d\r\n"
                 "Step: Period=%.0fmS, Rate=%.2fHz\r\n"
                 "Char: Period=%.0fmS, Rate=%.2fHz\r\n"
                 "Message Repeats: %.0f Seconds",
          new_rate,
          (1000.0/96.0)*(float)new_rate, 96.0/(float)new_rate,
          (1000.0*6.0/96.0)*(float)new_rate/((float)step_size),
          (((float)step_size)*96.0/6.0)/(float)new_rate,
          (display_size?
            ((6.0*40.0/96.0)*(float)new_rate):
            ((6.0*36.0/96.0)*(float)new_rate))
          /(float)step_size);
  m_Scroll_Rate_Prompt.SetWindowText(string);
  }
//------------------------------------------------------------------------------
void CScrollPopupDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
	Update_Scroll_Prompt();
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
  }
//------------------------------------------------------------------------------
void CScrollPopupDlg::OnCloseupScrollStepSize() 
  {
 	Update_Scroll_Prompt();
  }
//------------------------------------------------------------------------------
void CScrollPopupDlg::OnOK() 
  {
	scroll_step_size=m_Scroll_Step_Size.GetCurSel();
	scroll_row=m_Scroll_Row.GetCurSel();
	scroll_delay=105-m_Scroll_Rate.GetPos();

  CString
	  message_string;
  m_Scroll_Message_Text.GetWindowText(message_string);
	strcpy(scroll_message,(LPSTR)(const char *)message_string);

	CDialog::OnOK();
  }
//------------------------------------------------------------------------------
void CScrollPopupDlg::Update_Message_Prompt(void)
  {
  char
    string[200];
  CString
	  message_string;
  m_Scroll_Message_Text.GetWindowText(message_string);
	strcpy(string,(LPSTR)(const char *)message_string);
  int
    length;
  length=strlen(string);
  sprintf(string,"Enter Message (%d of %d characters used):",
          length,
          display_size?40:36);
  m_Scroll_Message_Prompt.SetWindowText(string);
  }
//------------------------------------------------------------------------------
char
  hereOnChangeScrollMessageText=0;
void CScrollPopupDlg::OnChangeScrollMessageText() 
  {
  if(!hereOnChangeScrollMessageText)
		{
    hereOnChangeScrollMessageText=1;
    //Get the string.
    char
      string[200];
    CString
  	  message_string;
    m_Scroll_Message_Text.GetWindowText(message_string);
  	strcpy(string,(LPSTR)(const char *)message_string);
    //Limit the length.
    int
      length;
    length=strlen(string);
    if(80<length)
      {
      string[80]=0;
      m_Scroll_Message_Text.SetWindowText(string);
      }
    Update_Message_Prompt();
    hereOnChangeScrollMessageText=0;
    }
  }
//------------------------------------------------------------------------------
void CScrollPopupDlg::OnCloseupScrollRow() 
  {
	char
	  message[80];
  if((1<m_Scroll_Row.GetCurSel())&&(!display_size))
    {
		sprintf(message,
            "Row %d only valid for 20x4 displays.",
			      m_Scroll_Row.GetCurSel()+1);
		MessageBox(message,"Crystalfontz WinTest", MB_ICONINFORMATION);
    m_Scroll_Row.SetCurSel(1);
    }
  }
//------------------------------------------------------------------------------
void CScrollPopupDlg::OnScrollGo() 
  {
  int
    i;
  //Get the string.
  char
    string[250];
  CString
	  message_string;
  m_Scroll_Message_Text.GetWindowText(message_string);
	strcpy(string,(LPSTR)(const char *)message_string);
  
  //Fill the string out with (40) spaces.
  strcat(string,"                                        ");
  Clear_Buffer();

  //Turn Scrolling off
	Buffer_Characters(4,22,255,1,5);

  //Move to the first column on the correct row, set wrapping off.
	Buffer_Characters(4,17,0,m_Scroll_Row.GetCurSel(),24);
  //Print out the part of the message that goes in the base display.
  for(i=0;i<=(display_size?19:15);i++)
		Buffer_Characters(1,string[i]);
  //Move the cursor to some other line, turn wrapping back on.
	Buffer_Characters(4,17,0,m_Scroll_Row.GetCurSel()?0:1,23);
  //Set the 20 hidden characters.
  for(i=0;i<=19;i++)
		Buffer_Characters(3,21,i,string[i+(display_size?20:16)]);
  //Enable scrolling on the correct row.
	Buffer_Characters(4,22,
                      m_Scroll_Row.GetCurSel(),
                      m_Scroll_Step_Size.GetCurSel()+1,
                      105-m_Scroll_Rate.GetPos());
	Send_Buffer();
	}
//------------------------------------------------------------------------------
void CScrollPopupDlg::OnScrollStop() 
	{
  Clear_Buffer();
	Buffer_Characters(7,22,255,1,5,12,7,31);
  for(int i=0;i<=19;i++)
		Buffer_Characters(3,21,i,' ');
	Send_Buffer();
	}
//------------------------------------------------------------------------------
