// WinTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WinTest.h"
#include "WinTestDlg.h"
#include "ScrollPopupDlg.h"
#include "math.h"
#include "serial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//==============================================================================
const char
	*port_names[9]=
   {"COM1","COM2","COM3","COM4","COM5","COM6","COM7","COM8","COM9"};
const char
	*speed_names[5]=
   {"1200","2400","4800","9600","19200"};
//------------------------------------------------------------------------------
void CWinTestDlg::set_serial(int port, int baud_rate, int dtr, int rts)
	{
	char
	  message[200];
  if(!Serial_Init(port,baud_rate,this))
		{
		CWaitCursor wait;
		set_dtr_rts(0,0);
		Sleep(1000);
		set_dtr_rts(m_dtr.GetCheck(),m_rts.GetCheck());

		sprintf(message,
            "Port %s opened at %s baud.",
			      port_names[port],
			      speed_names[baud_rate]);
		MessageBox(message,"Crystalfontz WinTest", MB_ICONINFORMATION);
		}
	else
		{
		sprintf(message,"Could not open port %s.",
						port_names[port]);
		MessageBox(message,"Error", MB_ICONEXCLAMATION);
		m_port.SetCurSel(-1);
		}
	}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinTestDlg dialog

CWinTestDlg::CWinTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinTestDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinTestDlg)
	DDX_Control(pDX, IDC_PORT_COMBO, m_port);
	DDX_Control(pDX, IDC_DISPLAY_TYPE, m_display_size);
	DDX_Control(pDX, IDC_CONTRAST_PERCENT, m_contrast_percent);
	DDX_Control(pDX, IDC_BACKLIGHT_PERCENT, m_backlight_percent);
	DDX_Control(pDX, IDC_CONTRAST_SLIDER, m_contrast);
	DDX_Control(pDX, IDC_BACKLGHT_SLIDER, m_backlight);
	DDX_Control(pDX, IDC_SPEED_COMBO, m_speed);
	DDX_Control(pDX, IDC_DEMO_COMBO, m_demo);
	DDX_Control(pDX, IDC_OUTPUT, m_output);
	DDX_Control(pDX, IDC_INPUT, m_input);
	DDX_Control(pDX, IDC_RTS_CHECK, m_rts);
	DDX_Control(pDX, IDC_DTR_CHECK, m_dtr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinTestDlg, CDialog)
	//{{AFX_MSG_MAP(CWinTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnExit)
	ON_BN_CLICKED(IDC_RTS_CHECK, OnRtsCheck)
	ON_BN_CLICKED(IDC_DTR_CHECK, OnDtrCheck)
	ON_EN_CHANGE(IDC_INPUT, OnChangeInput)
	ON_CBN_CLOSEUP(IDC_SPEED_COMBO, OnCloseupSpeedCombo)
	ON_CBN_CLOSEUP(IDC_PORT_COMBO, OnCloseupPortCombo)
	ON_BN_CLICKED(IDC_Execute_Demo, OnGoClick)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinTestDlg message handlers
char
  output_string[20*50+1+8000];

int
  last_contrast;
int
  last_backlight;

BOOL CWinTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

  // set the font of the response window to a fixed-pitch bugger
  HFONT m_hFont;
  CFont *m_pFont;

  m_hFont = (HFONT)GetStockObject(ANSI_FIXED_FONT);
  m_pFont = CFont::FromHandle (m_hFont);
  m_output.SetFont (m_pFont);


	m_speed.SetCurSel(4);
	m_rts.SetCheck(1);
	m_dtr.SetCheck(1);

  char
    string[10];

  //default is 20x4
  m_display_size.SetCurSel(1);

	m_contrast.SetRange(0, 100);
	m_contrast.SetPos(50);
  last_contrast=50;
  sprintf(string,"%d%%",last_contrast);
	m_contrast_percent.SetWindowText(string);

	m_backlight.SetRange(0, 100);
	m_backlight.SetPos(100);
  last_backlight=100;
  sprintf(string,"%d%%",last_backlight);
  m_backlight_percent.SetWindowText(string);

  sprintf(scroll_message,"Crystalfontz Scrolling Banner");
  scroll_delay=16;
  scroll_step_size=0;
  scroll_row=0;

	int
    success=0;
	//Set the port to the first one that will initialize.
	for(int port=0;port<=8;port++)
		{
		m_port.SetCurSel(port);
		if(!Serial_Init(m_port.GetCurSel(),m_speed.GetCurSel()))
			{
			success=1;
			break;
			}
		}

	if(success)
		{
		char
		  message[200];
		sprintf(message,"Port %s opened at %s baud.",
			port_names[m_port.GetCurSel()],
			speed_names[m_speed.GetCurSel()]);

		CWaitCursor wait;
		set_dtr_rts(0,0);
		Sleep(1000);
		set_dtr_rts(m_dtr.GetCheck(),m_rts.GetCheck());

		MessageBox(message,"Crystalfontz WinTest", MB_ICONINFORMATION);
		}
	else
		{
		m_port.SetCurSel(-1);
		MessageBox("Could not open any of the serial ports.",
    					  "Error", MB_ICONEXCLAMATION);
		}


  m_demo.SetCurSel(0);
		

	output_string[0]=0;
	
	//Seed random number generator.
	srand((unsigned)time(NULL));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWinTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//------------------------------------------------------------------------------
void CWinTestDlg::OnExit() 
	{
  Uninit_Serial();
	CDialog::OnOK();	
	}


void CWinTestDlg::OnRtsCheck() 
	{
	set_dtr_rts(m_dtr.GetCheck(),m_rts.GetCheck());
	}

void CWinTestDlg::OnDtrCheck() 
	{
	set_dtr_rts(m_dtr.GetCheck(),m_rts.GetCheck());
	}

void CWinTestDlg::OnCloseupSpeedCombo() 
	{
	set_serial(m_port.GetCurSel(),m_speed.GetCurSel(),
             m_dtr.GetCheck(),m_rts.GetCheck());
	}

void CWinTestDlg::OnCloseupPortCombo() 
	{
	set_serial(m_port.GetCurSel(),m_speed.GetCurSel(),
             m_dtr.GetCheck(),m_rts.GetCheck());
	}

const char
  *Control_Names[33]=
    {"Ctrl+@=NUL",
     "Ctrl+A=SOH",
     "Ctrl+B=STX",
     "Ctrl+C=ETX",
     "Ctrl+D=EOT",
     "Ctrl+E=ENQ",
     "Ctrl+F=ACK",
     "Ctrl+G=BEL",
     "Ctrl+H=BS",
     "Ctrl+I=HT",
     "Ctrl+J=LF",
     "Ctrl+K=VT",
     "Ctrl+L=FF",
     "Ctrl+M=CR",
     "Ctrl+N=SO",
     "Ctrl+O=SI",
     "Ctrl+P=DLE",
     "Ctrl+Q=DC1",
     "Ctrl+R=DC2",
     "Ctrl+S=DC3",
     "Ctrl+T=DC4",
     "Ctrl+U=NAK",
     "Ctrl+V=SYN",
     "Ctrl+W=ETB",
     "Ctrl+X=CAN",
     "Ctrl+Y=EM",
     "Ctrl+Z=SUB",
     "Ctrl+[=ESC",
     "Ctrl+\\=FS",
     "Ctrl+]=GS",
     "Ctrl+^=RS",
     "Ctrl+_=US",
     "Space"};


void CWinTestDlg::send_key(unsigned char key)
	{
	char
    keystring[80];

	Send_Character(key);

	if((key=='{')||(key=='}'))
		sprintf(keystring,"{%03d=0x%02X=\"%c\"}",key,key,key);
	else
		if(('!'<=key)&&(key<=126))
			sprintf(keystring,"%c",key);
		else
			if(key<=32)
				sprintf(keystring,"{%03d=0x%02X=\"%s\"}",key,key,Control_Names[key]);
			else
				sprintf(keystring,"{%03d=0x%02X}",key,key);
	strcat(output_string,keystring);
  //Trim the string down if we are about to blow out.
	if((sizeof(output_string)-8000-1)<strlen(output_string))
	  strcpy(output_string,
           &output_string[((strlen(output_string)-(sizeof(output_string)-8000-50))/50)*50]);
  m_output.SetWindowText(output_string);
	}
void CWinTestDlg::send_string(char *input)
	{
  char
    this_character; 
	while((this_character=*input++))
    send_key(this_character);
	}

void CWinTestDlg::send_keys(unsigned char count,
														unsigned char k0,
														unsigned char k1,
														unsigned char k2,
														unsigned char k3,
														unsigned char k4,
														unsigned char k5,
														unsigned char k6,
														unsigned char k7,
														unsigned char k8,
														unsigned char k9)
	{
	if(0<count)
    send_key(k0);
	if(1<count)
    send_key(k1);
	if(2<count)
    send_key(k2);
	if(3<count)
    send_key(k3);
	if(4<count)
    send_key(k4);
	if(5<count)
    send_key(k5);
	if(6<count)
    send_key(k6);
	if(7<count)
    send_key(k7);
	if(8<count)
    send_key(k8);
	if(9<count)
    send_key(k9);
	}

char
  hereOnChangeInput=0;
void CWinTestDlg::OnChangeInput() 
	{
  if(!hereOnChangeInput)
		{
    hereOnChangeInput=1;
	  CString
	    input_string;
		char
		  string[800];
		m_input.GetWindowText(input_string);
		strcpy(string,(LPSTR)(const char *)input_string);
		while(*string)
			{
			if(string[0]=='\\')
				{
				if(string[1]=='\\')
					{
					send_key('\\');
					strcpy(string,&string[2]);
					}
				else
					{
					if((('0'<=string[1])&&(string[1]<='9'))&&
             (('0'<=string[2])&&(string[2]<='9'))&&
             (('0'<=string[3])&&(string[3]<='9')))
						{
						char
							input[4];
						input[0]=string[1];
						input[1]=string[2];
						input[2]=string[3];
						input[3]=0;
						int
							value;
						sscanf(input,"%d",&value);
						if(value<0)
							value=0;
						if(255<value)
							value=255;
						send_key(value);
						strcpy(string,&string[4]);
						}
					else
						{
						//These are the only valid partial strings.
						if(string[1]==0)
							break;
						if((('0'<=string[1])&&(string[1]<='9'))&&
							 (string[2]==0))
							break;
						if((('0'<=string[1])&&(string[1]<='9'))&&
						   (('0'<=string[2])&&(string[2]<='9'))&&
							 (string[3]==0))
							break;
						//Invalid partial string, dump it out.
						send_key(*string);
						strcpy(string,&string[1]);
						}
					}
				}
			else
				{
				send_key(*string);
				strcpy(string,&string[1]);
				}
			}
		if(!string[0])
			m_input.SetWindowText("");
    hereOnChangeInput=0;
		}
	}

BOOL CWinTestDlg::PreTranslateMessage(LPMSG lpmsg)
  {
  BOOL
		bHandleNow = FALSE;

  switch (lpmsg->message)
    {
    case WM_KEYDOWN:
      switch (lpmsg->wParam)
        {
        case VK_UP:
					send_keys(3,27,'[','A');
          bHandleNow = TRUE;
          break;
        case VK_DOWN:
					send_keys(3,27,'[','B');
          bHandleNow = TRUE;
          break;
		    case VK_RIGHT:
					send_keys(3,27,'[','C');
          bHandleNow = TRUE;
          break;
        case VK_LEFT:
					send_keys(3,27,'[','D');
          bHandleNow = TRUE;
          break;
				}
			break;
  case WM_CHAR:
			if(lpmsg->wParam<32)
				{
				send_key(lpmsg->wParam);
        bHandleNow = TRUE;
				}
    }
  if(bHandleNow)
		{
	  OnKeyDown(lpmsg->wParam, LOWORD(lpmsg->lParam), HIWORD(lpmsg->lParam));
    m_input.SetFocus();
		}
  return bHandleNow;
	}
//------------------------------------------------------------------------------
void CWinTestDlg::OnGoClick(void) 
	{
	switch(m_demo.GetCurSel())
		{
		case 0: //Scroll
			OnScrollDemo();
			break;
		case 1: //Graph
      if(m_display_size.GetCurSel())
				OnGRAPHDEMO4x20();
			else
				OnGRAPHDEMO2x16();
			break;
    case 2: //3x4 Big Numbers
		  if(m_display_size.GetCurSel())
				OnBIGNUM3x4DEMO();
      else
				MessageBox("Large number demos only valid on the 20x4 display.","Crystalfontz WinTest", MB_ICONINFORMATION);
			break;
    case 3: //4x4 Big Numbers
		  if(m_display_size.GetCurSel())
				OnBIGNUM4x4DEMO();
      else
				MessageBox("Large number demos only valid on the 20x4 display.","Crystalfontz WinTest", MB_ICONINFORMATION);
			break;
    case 4: //Spectrum Demo
		  if(m_display_size.GetCurSel())
				OnSpectraDemo20x4();
      else
				OnSpectraDemo16x2();
			break;
    case 5: //O'scope Demo
				OnOscopeDemo();
			break;
		default:	
			MessageBox("Invalid Demonstration Choice","Error", MB_ICONEXCLAMATION);
		} 
	}
//------------------------------------------------------------------------------
void CWinTestDlg::OnGRAPHDEMO2x16(void) 
	{
  //0123456789012345
  //Tmp:wwwxxxyyyzzz
  //Vol:---+++Pr:xxx         

  //CtrlZ,Graph,Style,StartChar,EndChar,Length,Row
	CWaitCursor wait;
  Clear_Buffer(); 
	//Scroll off, clear the display, hide cursor
	Buffer_Characters(6,22,255,1,5,12,4);
	Buffer_String("Tmp:");
	Buffer_Characters(3,17,0,1);
	Buffer_String("Vol:");
	Buffer_Characters(3,17,10,1);
	Buffer_String("Pr:");

	int
		i;  

  int
    ramp_val;
  int
    last_sign;
  int
    direction;

  last_sign=0;
  ramp_val=0;
  direction=1;

  int
    loop;
	for(loop=0;loop<=m_speed.GetCurSel();loop++)
		{
	  for(i=0;i<=12*6;i++)
			{
			//Temperature
	  	Buffer_Characters(7,18,0,0xFF,4,15,i,0);

  		Buffer_Characters(7,18,1,0x3C,13,15,(int)(18.0*sin((i*3.14159265359)/72.0)),1);
	
			ramp_val+=direction;
			if((0<direction)&&(18<=ramp_val))
			  direction=-1;
			else
		    if((direction<0)&&(ramp_val<-18))
					direction=1;

  		Buffer_Characters(7,18,2,0x55,4,6,ramp_val<0?ramp_val:0,1);
  		Buffer_Characters(7,18,2,0x55,7,9,0<ramp_val?ramp_val:0,1);
			}
		
	  for(i=12*6;0<=i;i--)
			{
			//Temperature
	  	Buffer_Characters(7,18,0,0xFF,4,15,i,0);
  		Buffer_Characters(7,18,1,0x3C,13,15,-(int)(18.0*sin((i*3.14159265359)/72.0)),1);
	
			ramp_val+=direction;
			if((0<direction)&&(18<=ramp_val))
			  direction=-1;
			else
		    if((direction<0)&&(ramp_val<-18))
					direction=1;

  		Buffer_Characters(7,18,2,0x36,4,6,ramp_val<0?ramp_val:0,1);
  		Buffer_Characters(7,18,2,0x36,7,9,0<ramp_val?ramp_val:0,1);
			}
		}

	//Show banner, reenable cursor
	Buffer_Characters(2,31,7);
  Send_Buffer();
	}
//------------------------------------------------------------------------------
void CWinTestDlg::OnGRAPHDEMO4x20(void) 
	{
  //01234567890123456789
  //Graph Demonstration
  //Temp:xxxxxxxxxxxxxx
  //Pres:yyyyyyyyyyyyyy
  //Vol :-------+++++++

  //CtrlZ,Graph,Style,StartChar,EndChar,Length,Row
	CWaitCursor wait;
	Clear_Buffer();

	//Scroll off, clear the display, hide cursor
	Buffer_Characters(6,22,255,1,5,12,4);

	Buffer_String("Graph Demonstration");
	Buffer_Characters(3,17,0,1);
	Buffer_String("Temp:");
	Buffer_Characters(3,17,0,2);
	Buffer_String("Pres:");
	Buffer_Characters(3,17,0,3);
	Buffer_String("Vol :");

	int
		i;  

  int
    ramp_val;
  int
    direction;

	ramp_val=0;
  direction=2;

  int
    loop;
	for(loop=0;loop<=m_speed.GetCurSel();loop++)
		{
	  for(i=0;i<=14*6;i++)
			{
	  	Buffer_Characters(7,18,0,0xFF,5,18,i,1);
			Buffer_Characters(7,18,1,0x3C,5,18,(int)(84.0*sin((i*3.14159265359)/84.0)),2);
	
			ramp_val+=direction;
			if((0<direction)&&(42<=ramp_val))
			  direction=-2;
			else
		    if((direction<0)&&(ramp_val<-42))
					direction=2;

  		Buffer_Characters(7,18,2,0x55,5,11,ramp_val<0?ramp_val:0,3);
  		Buffer_Characters(7,18,3,0x55,12,18,0<ramp_val?ramp_val:0,3);
			}
	
	  for(i=14*6;0<=i;i--)
			{
  		Buffer_Characters(7,18,0,0xFF,5,18,i,1);
			Buffer_Characters(7,18,1,0x3C,5,18,-(int)(84.0*sin((i*3.14159265359)/84.0)),2);
		
			ramp_val+=direction;
			if((0<direction)&&(42<= ramp_val))
	      direction=-2;
			else
		    if((direction<0)&&(ramp_val<-42))
					direction=2;
	
  		Buffer_Characters(7,18,2,0x36,5,11,ramp_val<0?ramp_val:0,3);
  		Buffer_Characters(7,18,3,0x36,12,18,0<ramp_val?ramp_val:0,3);
			}
		}
	
	//Show banner, reenable cursor
	Buffer_Characters(3,31,7);

	Send_Buffer();
  output_string[0]=0;
  m_output.SetWindowText(output_string);	
	}
//------------------------------------------------------------------------------
void CWinTestDlg::OnScrollDemo(void) 
	{
  //Declare the popup.
  CScrollPopupDlg
    dlg;
  // Initialize dialog data

  dlg.display_size=m_display_size.GetCurSel();
  dlg.scroll_delay=scroll_delay;
  dlg.scroll_step_size=scroll_step_size;
  dlg.scroll_row=scroll_row;
  strcpy(dlg.scroll_message,scroll_message);

  // Invoke the dialog box
  if(dlg.DoModal() == IDOK)
    {
    // retrieve the dialog data
    scroll_delay=dlg.scroll_delay;
    scroll_step_size=dlg.scroll_step_size;
    scroll_row=dlg.scroll_row;
    strcpy(scroll_message,dlg.scroll_message);
    }
	}
//------------------------------------------------------------------------------
void CWinTestDlg::OnBIGNUM3x4DEMO(void) 
	{

	CWaitCursor wait;
  Clear_Buffer();

	//Scroll off, clear the display, hide cursor
	Buffer_Characters(6,22,255,1,5,12,4);

  //01234567890123456789
  //3x4  111 222 333 444
  //Big  111 222 333 444
  //Num  111 222 333 444
  //Demo 111 222 333 444

  //Label
	Buffer_String("3x4");
	Buffer_Characters(3,17,0,1);
  Buffer_String("Big");
	Buffer_Characters(3,17,0,2);
	Buffer_String("Num");
	Buffer_Characters(3,17,0,3);
	Buffer_String("Demo");
  Send_Buffer();

#define REPS 25
  
	char
    string[10];
	int
		i;
	for(i=0;i<=REPS;i++)
		{
		sprintf(string,"%04d",rand()%10000);
		Buffer_Characters(4,28,0,5,string[0]);
		Buffer_Characters(4,28,0,9,string[1]);
		Buffer_Characters(4,28,0,13,string[2]);
		Buffer_Characters(4,28,0,17,string[3]);
	  Send_Buffer();
    Sleep(i*10);
		}

	for(i=0;i<=REPS;i++)
		{
		sprintf(string,"9%03d",rand()%1000);
		Buffer_Characters(4,28,0,5,string[0]);
		Buffer_Characters(4,28,0,9,string[1]);
		Buffer_Characters(4,28,0,13,string[2]);
		Buffer_Characters(4,28,0,17,string[3]);
	  Send_Buffer();
    Sleep(i*10);
		}

	for(i=0;i<=REPS;i++)
		{
		sprintf(string,"97%02d",rand()%100);
		Buffer_Characters(4,28,0,5,string[0]);
		Buffer_Characters(4,28,0,9,string[1]);
		Buffer_Characters(4,28,0,13,string[2]);
		Buffer_Characters(4,28,0,17,string[3]);
	  Send_Buffer();
    Sleep(i*10);
		}

	for(i=0;i<=REPS;i++)
		{
		sprintf(string,"972%01d",rand()%10);
		Buffer_Characters(4,28,0,5,string[0]);
		Buffer_Characters(4,28,0,9,string[1]);
		Buffer_Characters(4,28,0,13,string[2]);
		Buffer_Characters(4,28,0,17,string[3]);
	  Send_Buffer();
    Sleep(i*10);
		}

	for(i=0;i<=REPS/2;i++)
		{
		sprintf(string,"9720%d",rand()%10);
		Buffer_Characters(4,28,0,5,string[0]);
		Buffer_Characters(4,28,0,9,string[1]);
		Buffer_Characters(4,28,0,13,string[2]);
		Buffer_Characters(4,28,0,17,string[3]);
	  Send_Buffer();
    Sleep(i*10);
		}

#undef REPS

	for(int startcol=0;-52<=startcol;startcol--)
		{
	  Buffer_Characters(1,12);
	  Buffer_Characters(4,28,0,startcol+16,'0');
	  Buffer_Characters(4,28,0,startcol+20,'1');
	  Buffer_Characters(4,28,0,startcol+24,'2');
	  Buffer_Characters(4,28,0,startcol+28,'3');
	  Buffer_Characters(4,28,0,startcol+32,'4');
	  Buffer_Characters(4,28,0,startcol+36,'5');
	  Buffer_Characters(4,28,0,startcol+40,'6');
	  Buffer_Characters(4,28,0,startcol+44,'7');
	  Buffer_Characters(4,28,0,startcol+48,'8');
	  Buffer_Characters(4,28,0,startcol+52,'9');
		Send_Buffer();
	  Sleep(200);
		}

	//Show banner, reenable cursor
	Buffer_Characters(2,31,7);
	Send_Buffer();
  output_string[0]=0;

  strcpy(output_string,"{3x4 Large Digits Demo Done}");
  m_output.SetWindowText(output_string);	
	}
//------------------------------------------------------------------------------
void CWinTestDlg::OnBIGNUM4x4DEMO(void) 
	{
	CWaitCursor wait;
  Clear_Buffer();
	//Scroll off, clear the display, hide cursor
	Buffer_Characters(6,22,255,1,5,12,4);

  //01234567890123456789
  //4x4  1111 2222 3333
  //Big  1111 2222 3333
  //Num  1111 2222 3333
  //Demo 1111 2222 3333

  //Label
	Buffer_String("4x4");
	Buffer_Characters(3,17,0,1);
  Buffer_String("Big");
	Buffer_Characters(3,17,0,2);
	Buffer_String("Num");
	Buffer_Characters(3,17,0,3);
	Buffer_String("Demo");
  Send_Buffer();

#define REPS 25

	char
    string[10];
	int
		i;

	for(i=0;i<=REPS;i++)
		{
		sprintf(string,"%03d",rand()%1000);
		Buffer_Characters(4,28,1,5,string[0]);
		Buffer_Characters(4,28,1,10,string[1]);
		Buffer_Characters(4,28,1,15,string[2]);
		Send_Buffer();
    Sleep(i*10);
		}

	for(i=0;i<=REPS;i++)
		{
		sprintf(string,"2%02d",rand()%100);
		Buffer_Characters(4,28,1,5,string[0]);
		Buffer_Characters(4,28,1,10,string[1]);
		Buffer_Characters(4,28,1,15,string[2]);
	  Send_Buffer();
    Sleep(i*10);
		}

	for(i=0;i<=REPS;i++)
		{
		sprintf(string,"20%01d",rand()%10);
		Buffer_Characters(4,28,1,5,string[0]);
		Buffer_Characters(4,28,1,10,string[1]);
		Buffer_Characters(4,28,1,15,string[2]);
	  Send_Buffer();
    Sleep(i*10);
		}

	for(i=0;i<=REPS/2;i++)
		{
		sprintf(string,"206%d",rand()%10);
		Buffer_Characters(4,28,1,5,string[0]);
		Buffer_Characters(4,28,1,10,string[1]);
		Buffer_Characters(4,28,1,15,string[2]);
	  Send_Buffer();
    Sleep(i*10);
		}

#undef REPS

	for(int startcol=0;-60<=startcol;startcol--)
		{
	  Buffer_Characters(1,12);
	  Buffer_Characters(4,28,1,startcol+15,'0');
	  Buffer_Characters(4,28,1,startcol+20,'1');
	  Buffer_Characters(4,28,1,startcol+25,'2');
	  Buffer_Characters(4,28,1,startcol+30,'3');
	  Buffer_Characters(4,28,1,startcol+35,'4');
	  Buffer_Characters(4,28,1,startcol+40,'5');
	  Buffer_Characters(4,28,1,startcol+45,'6');
	  Buffer_Characters(4,28,1,startcol+50,'7');
	  Buffer_Characters(4,28,1,startcol+55,'8');
	  Buffer_Characters(4,28,1,startcol+60,'9');
		Send_Buffer();
	  Sleep(200);
		}

	//Show banner, reenable cursor
	Buffer_Characters(2,31,7);
	Send_Buffer();
  output_string[0]=0;

  strcpy(output_string,"{4x4 Large Digits Demo Done}");
  m_output.SetWindowText(output_string);	
	}
//------------------------------------------------------------------------------
void CWinTestDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
	int
    new_contrast;
  char
    string[10];
  new_contrast=m_contrast.GetPos();
	if(last_contrast!=new_contrast)
		{
	  Clear_Buffer();
		Buffer_Characters(2,15,new_contrast);
	  Send_Buffer();

    sprintf(string,"%d%%",new_contrast);
		m_contrast_percent.SetWindowText(string);
    last_contrast=new_contrast;
		}

	int
    new_backlight;
  new_backlight=m_backlight.GetPos();
	if(last_backlight!=new_backlight)
		{
	  Clear_Buffer();
		Buffer_Characters(2,14,new_backlight);
	  Send_Buffer();

    sprintf(string,"%d%%",new_backlight);
		m_backlight_percent.SetWindowText(string);

    last_backlight=new_backlight;
		}
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
  }
//------------------------------------------------------------------------------
void Setup_Custom_Characters_For_Spectrum(void)
	{
	//Program the special characters to be the
	//partial bar heights.
	Buffer_Characters(10,25,0,0,0,0,0,0,0,0,63);
	Buffer_Characters(10,25,1,0,0,0,0,0,0,63,63);
	Buffer_Characters(10,25,2,0,0,0,0,0,63,63,63);
	Buffer_Characters(10,25,3,0,0,0,0,63,63,63,63);
	Buffer_Characters(10,25,4,0,0,0,63,63,63,63,63);
	Buffer_Characters(10,25,5,0,0,63,63,63,63,63,63);
	Buffer_Characters(10,25,6,0,63,63,63,63,63,63,63);
	Buffer_Characters(10,25,7,63,63,63,63,63,63,63,63);
	}
//------------------------------------------------------------------------------
void Display_20x4_Spectrum(char data[])
	{
	unsigned char
		display[80];
	int
		row,col;
	memset(display,' ',80);
	for(col=0;col<=19;col++)
		{
		//solid characters
		for(row=0;row<(data[col]/8);row++)
			display[(3-row)*20+col]=135;
		//partial character
		if(data[col]&0x07)
			display[(3-row)*20+col]=128+(data[col]&0x07);
		}
	for(row=0;row<=3;row++)
		{
		Buffer_Characters(3,17,0,row);
		for(col=0;col<=19;col++)
			Buffer_Characters(1,display[col+row*20]);
		}
	}
//------------------------------------------------------------------------------
void CWinTestDlg::OnSpectraDemo20x4(void) 
	{
  char
		spectrum[20];
	int
		i;

	CWaitCursor wait;
  Clear_Buffer();

	//Initialize the spectrum to a flat line.
	for(i=0;i<=19;i++)
		spectrum[i]=15;


	//Scroll off, clear the display, hide cursor
	Buffer_Characters(8,22,255,1,5,12,23,20,4);
  Setup_Custom_Characters_For_Spectrum();
  Send_Buffer();

#define REPS 50
	for(i=0;i<=REPS*(m_speed.GetCurSel()+1);i++)
#undef REPS
		{
		//Walk each bin up or down by 1 or 2 pels.
		for(int bin=0;bin<=19;bin++)
			{
			if(bin<10)
				spectrum[bin]+=(rand() % 3)-1;
			else
				spectrum[bin]+=(rand() % 5)-2;
			//Clip.
			if(31<spectrum[bin])
				spectrum[bin]=31;
			else
				if(spectrum[bin]<0)
					spectrum[bin]=0;
			}
		Display_20x4_Spectrum(spectrum);
		Send_Buffer();
		}

	//Show banner, reenable cursor
	Buffer_Characters(2,31,7);
	Send_Buffer();

  output_string[0]=0;
  strcpy(output_string,"{20x4 Spectrum Demo Done}");
  m_output.SetWindowText(output_string);	
	}
//------------------------------------------------------------------------------
void Display_16x2_Spectrum(char data[])
	{
	unsigned char
		display[32];
	int
		row,col;
	memset(display,' ',32);
	for(col=0;col<=15;col++)
		{
		//solid characters
		for(row=0;row<(data[col]/8);row++)
			display[(1-row)*16+col]=135;
		//partial character
		if(data[col]&0x07)
			display[(1-row)*16+col]=128+(data[col]&0x07);
		}
	for(row=0;row<=1;row++)
		{
		Buffer_Characters(3,17,0,row);
		for(col=0;col<=15;col++)
			Buffer_Characters(1,display[col+row*16]);
		}
	}
//------------------------------------------------------------------------------
void CWinTestDlg::OnSpectraDemo16x2(void) 
	{
  char
		spectrum[16];
	int
		i;

	CWaitCursor wait;
  Clear_Buffer();

	//Initialize the spectrum to a flat line.
	for(i=0;i<=15;i++)
		spectrum[i]=7;


	//Scroll off, clear the display, hide cursor
	Buffer_Characters(8,22,255,1,5,12,23,20,4);
  Setup_Custom_Characters_For_Spectrum();
  Send_Buffer();

#define REPS 50
	for(i=0;i<=REPS*(m_speed.GetCurSel()+1);i++)
#undef REPS
		{
		//Walk each bin up or down by 1 or 2 pels.
		for(int bin=0;bin<=15;bin++)
			{
			if(bin<8)
				spectrum[bin]+=(rand() % 3)-1;
			else
				spectrum[bin]+=(rand() % 5)-2;
			//Clip.
			if(15<spectrum[bin])
				spectrum[bin]=15;
			else
				if(spectrum[bin]<0)
					spectrum[bin]=0;
			}
		Display_16x2_Spectrum(spectrum);
		Send_Buffer();
		}

	//Show banner, reenable cursor
	Buffer_Characters(2,31,7);
	Send_Buffer();

  output_string[0]=0;
  strcpy(output_string,"{16x2 Spectrum Demo Done}");
  m_output.SetWindowText(output_string);	
	}
//------------------------------------------------------------------------------
// This puts the "Oscope" in the upper left, so it works for both 16x2 and 20 x4
// 0123456789012345
// Oscilloscope:
//     12345678
//Reasonable Rounding and clipping conversion from float to int.
int get_int(double input)
  {
  if(32767.0<input)
    return(0x7FFF);
  if(input<-32768.0)
    return(0x8000);

  double
    return_value;

  if(fabs(modf(input,&return_value))>0.5)
    return_value+=input<0.0?-1.0:1.0;

  return((int)return_value);
  }

void CWinTestDlg::OnOscopeDemo(void) 
	{
  const
    bits[6] = {32,16,8,4,2,1};
  char
		bitmap[8*8];
	int
		x,y,start_y,i,j;

	CWaitCursor wait;
  Clear_Buffer();

	//Scroll off, clear the display, hide cursor
	Buffer_Characters(8,22,255,1,5,12,23,20,4);
	Buffer_String("Oscilloscope");
	Buffer_Characters(3,17,4,1);
  Buffer_Characters(8,128,129,130,131,132,133,134,135);
  Send_Buffer();

	//Random Walk
  start_y = rand() % 8;
#define REPS 5
	for(i=0;i<=REPS*(m_speed.GetCurSel()+1);i++)
#undef REPS
		{
  	//Clear the bitmap.
	  memset(bitmap,0,sizeof(bitmap));
		//Draw the trace
    y = start_y;
    for(x=0;x<=47;x++)
	    {
  		//Set the pixel at X,Y.
	  	bitmap[8*(x/6)+y]|= bits[(x % 6)];
			//Random walk Y, then clip.
      y+=(rand() % 3)-1;
      if(y<0)
	      y=0;
	    else
        if(y>7)
	        y=7;
			if(!x)
				start_y=y;
			}
		//Update the custom character definitions.
    for(j=0;j<=7;j++)
		  Buffer_Characters(10,25,j,
                        bitmap[j*8],
                        bitmap[j*8+1],
                        bitmap[j*8+2],
                        bitmap[j*8+3],
                        bitmap[j*8+4],
                        bitmap[j*8+5],
                        bitmap[j*8+6],
                        bitmap[j*8+7]);
		//Update this frame.
		Send_Buffer();
		//Let the LCD respond.
    Sleep(40*m_speed.GetCurSel());
		}

   //Sine. The aliasing looked cool, so it stayed.
   float
     phase=0.0;
   float
     delta_phase=(float)0.0005;
#define REPS 40
	for(i=0;i<=REPS*(m_speed.GetCurSel()+1);i++)
#undef REPS
		{
  	//Clear the bitmap.
	  memset(bitmap,0,sizeof(bitmap));
		//Draw the trace
    for(x=0;x<=47;x++)
	    {
			y=get_int((3.5+(3.1*sin(0.3272492348*x+phase))));
  		//Set the pixel at X,Y.
	  	bitmap[8*(x/6)+y]|= bits[(x % 6)];
			phase-=delta_phase;
      delta_phase+=(float)0.00006;
			}
		//Update the custom character definitions.
    for(j=0;j<=7;j++)
		  Buffer_Characters(10,25,j,
                        bitmap[j*8],
                        bitmap[j*8+1],
                        bitmap[j*8+2],
                        bitmap[j*8+3],
                        bitmap[j*8+4],
                        bitmap[j*8+5],
                        bitmap[j*8+6],
                        bitmap[j*8+7]);
		//Update this frame.
		Send_Buffer();
		//Let the LCD respond.
    Sleep(20*m_speed.GetCurSel());
		}


	//Show banner, reenable cursor
	Buffer_Characters(2,31,7);
	Send_Buffer();

  output_string[0]=0;
  strcpy(output_string,"{Oscilloscope Demo Done}");
  m_output.SetWindowText(output_string);	
	}
//------------------------------------------------------------------------------
